answer/urls.py
from django.urls import path
from . import views

app_name = 'answer'

urlpatterns = [
    path('answer-create/<int:question_id>/', views.answer_create, name='answer_create'),
    path('answer-update/<int:question_id>/<int:answer_id>/', views.answer_update, name='answer_update'),
    path('answer-delete/<int:question_id>/<int:answer_id>/', views.answer_delete, name='answer_delete'),
    path('answer-download/<int:id>/', views.download_file, name='download_file'),
]

collect/urls.py
#!/usr/bin/env python 
# -*- coding:utf-8 -*-
from django.urls import path
from . import views

app_name = 'collect'

urlpatterns = [
    path('collect-change/', views.collect_change, name='collect_change'),
]

like/urls.py
from django.urls import path
from . import views

app_name = 'like'

urlpatterns = [
    path('like-change/', views.like_change, name='like_change'),
]

question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [

    # 文章详情
    path('question-detail/<int:id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:id>/', views.question_update, name='question_update'),
    path('question-delete/<int:id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from article import views as article_views
from question import views as question_views
from userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
from itertools import chain
import notifications.urls
def mainPage(request):
    return render(request, 'userprofile/collection.html', {})

def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list(request)
    hot_articles = article_views.hot_article_list(request)
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('userprofile.urls', namespace='userprofile')),
    path('article/', include('article.urls', namespace='article')),
    path('question/', include('question.urls', namespace='question')),
    path('comment/', include('comment.urls', namespace='comment')),
    path('answer/', include('answer.urls', namespace='answer')),
    path('like/', include('like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

question/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from django.urls import reverse
from django.contrib.contenttypes.fields import GenericRelation
from like.models import LikeRecord
from collect.models import CollectRecord
from taggit.managers import TaggableManager


# 提问板块模型
class QuestionColumn(models.Model):
    # 板块标题
    title = models.CharField(max_length=100, blank=True)

    def __str__(self):
        return self.title


# 博客问题数据模型
class QuestionPost(models.Model):
    # 问题作者。
    author = models.ForeignKey(User, on_delete=models.CASCADE)

    # 问题版块。
    column = models.ForeignKey(
        QuestionColumn,
        null=True,
        blank=True,
        on_delete=models.CASCADE,
        related_name='question'
    )

    # 问题标签
    forum = TaggableManager(blank=True)

    # 问题标题。
    title = models.CharField(max_length=100)

    # 问题描述。
    description = models.TextField(max_length=500)

    # 问题创建时间。参数 default=timezone.now 指定其在创建数据时将默认写入当前的时间
    created = models.DateTimeField(default=timezone.now)

    # 问题更新时间。参数 auto_now=True 指定每次数据更新时自动写入当前时间
    updated = models.DateTimeField(auto_now=True)

    # 上传文件
    file = models.FileField(upload_to='question_file/%Y%m%d/', blank=True)

    # 点赞记录
    like_records = GenericRelation(LikeRecord, related_query_name='articles')

    # 收藏记录
    collect_records = GenericRelation(CollectRecord, related_query_name='questions')
    
    # 浏览量
    total_views = models.PositiveIntegerField(default=0)

    class Meta:
        # ordering 指定模型返回的数据的排列顺序
        # '-created' 表明数据应该以创建时间的倒序排列
        ordering = ('-created',)

    def __str__(self):
        # 将问题标题返回
        return self.title
    
    # 获得问题详细页面url
    def get_absolute_url(self):
        return reverse('question:question_detail', args=[self.id])

    # 问题是否收藏
    def question_is_collected(self, user):
        collect_records = self.collect_records.filter(user=user)
        return len(collect_records) != 0

    # 问题是否点赞
    def question_is_liked(self, user):
        like_records = self.like_records.filter(user=user)
        return len(like_records) != 0

    # 问题创建时间是否错误
    def was_created_recently(self):
        diff = timezone.now() - self.created
        
        if diff.days == 0 and diff.seconds >= 0 and diff.seconds < 60:
            return True
        else:
            return False

    # 问题更新时间是否错误
    def was_updated_recently(self):
        diff = timezone.now() - self.updated
        
        if diff.days == 0 and diff.seconds >= 0 and diff.seconds < 60:
            return True
        else:
            return False

question/forms.py
from django import forms
from .models import QuestionPost


# 发布问题的表单类
class QuestionPostForm(forms.ModelForm):
    class Meta:
        # 指明数据模型来源
        model = QuestionPost
        # 定义表单包含的字段:问题属于的分区，标题，描述，标签
        fields = ('title', 'description','file', 'forum')

question/views.py
from django.shortcuts import render, redirect, reverse
from .models import QuestionPost, QuestionColumn
from .forms import QuestionPostForm
from django.contrib.auth.models import User
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from answer.models import Answer
import os
from django.http import HttpResponse,StreamingHttpResponse
from django.conf import settings
from django.utils.http import urlquote
# 引入 Q 对象
from django.db.models import Q
# 引入分页模块
from django.core.paginator import Paginator
#引入权限检查模块
from django.contrib.auth.models import Permission
import markdown
from django.utils.html import strip_tags  #去掉所有html标签
#搜索问题
def search_question(request):
    # 判断是否进行了搜索

    search = request.GET.get('search')
    # 如果进行了搜索
    if search:
        questions = QuestionPost.objects.filter(
            # 匹配标题(不区分大小写)
            Q(title__icontains=search) |
            # 匹配问题描述(不区分大小写)
            Q(description__icontains=search)
        ).order_by('-updated')
        context = {'questions': questions,'search_q': search}
    # 如果未进行搜索
    else:
        # 修改变量名称（articles -> article_list）
        question_list = QuestionPost.objects.all()
        # 每页显示 1 篇文章
        paginator = Paginator(question_list, 5)
        # 获取 url 中的页码
        page = request.GET.get('page')
        # 将导航对象相应的页码内容返回给 articles
        questions = paginator.get_page(page)
        context = {'questions': questions,'search_q': search}
    return render(request, 'search/search_question.html', context)

# 热门问题
def hot_question_list(request):
    def sorts():
        sort = ['-total_views', '-updated']
        return sort

    ## 取出所有问题
    questions = list(QuestionPost.objects.order_by(*sorts())[:5])

    # # 将问题标题构成list
    hot_titles = [question.title for question in questions]
    # # 如果list长度不足5，则用'...'补齐
    hot_titles += ['...' for i in range(5 - len(questions))]
    # # 将问题id构成list
    hot_ids = [question.id for question in questions]
    # # 如果list长度不足5，则用'...'补齐
    hot_ids += [0 for i in range(5 - len(questions))]
    # # 将title list传递给模板（templates）
    context = {'questions': questions}
    # # render函数：载入模板，并返回context对象
    return context


# 板块问题
def column_question_list():
    questions = QuestionPost.objects.all().order_by('column', '-updated')
    context = {'column_questions': questions}
    return context


# 问题详情
def question_detail(request, id):
    question = QuestionPost.objects.get(id=id)
    # 更新浏览量
    question.total_views += 1
    # 保存新的浏览量
    question.save(update_fields=['total_views'])
    question.description = strip_tags(question.description)
    question.description = markdown.markdown( question.description,
        extensions=[
        # 包含 缩写、表格等常用扩展
        'markdown.extensions.extra',
        # 语法高亮扩展
        'markdown.extensions.codehilite',
        ])
    answers = Answer.objects.filter(question=id)
    context = {'question': question, 'answers': answers}
    # download_file(request,id)
    return render(request, 'question/detail.html', context)


# 发布问题
@login_required(login_url='/userprofile/login/')
def question_create(request):
    # 判断该用户是否有相关权限
    myuser = User.objects.get(id=request.user.id)
    if not myuser.has_perm('question.add_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')
    # 判断用户是否提交数据
    if request.method == "POST":
        # 将提交的数据赋值到表单实例
        question_post_form = QuestionPostForm(request.POST,request.FILES)
        # 判断提交的数据是否满足要求
        if question_post_form.is_valid():
            # 保存数据，但暂时不提交到数据库
            new_question = question_post_form.save(commit=False)
            # 指定数据库中 当前的用户
            new_question.author = User.objects.get(id=request.user.id)
            # 所有问题都需要归属于一个板块
            new_question.column = QuestionColumn.objects.get(id=request.POST['column'])
            # 将文章保存至数据库
            new_question.save()
            # 保存 tags 的多对多关系
            question_post_form.save_m2m()
            # 完成后提示发表成功
            messages.success(request, "发表问题成功。")
            # 完成后返回到文章详情
            return redirect("question:question_detail", id=new_question.id)
        # 数据不合法 ，返回错误信息
        else:
            columns = QuestionColumn.objects.all()
            context = {'question_post_form': question_post_form, 'columns': columns}    #debug
            messages.error(request, "表单内容有误，请重新填写。")
            return render(request, "question/create.html", context)
    # 如果用户请求获取数据
    else:
        # 创建表单实例
        question_post_form = QuestionPostForm()
        # 赋值上下文
        context = {'question_post_form': question_post_form}
        # 返回模板
        return render(request, 'question/create.html', context)


# 更新问题
@login_required(login_url='/userprofile/login/')
def question_update(request, id):
    """
    更新文章视图
    通过POST提交表单，更新 title,body字段
    GET方法进入初始界面
    id: 问题id
    """
    # 判断该用户是否有相关权限
    myuser = User.objects.get(id=request.user.id)
    if not myuser.has_perm('question.change_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')
    # 获取需要修改的具体文章的对象
    question = QuestionPost.objects.get(id=id)
    #answers = Answer.objects.filter(question_id=id)
    if request.user != question.author:  # 4.25 17:21 增添 只能删除本人的问题
        messages.error(request, "抱歉，你无权修改这篇文章")
        return redirect(question)
    # 判断用户是否为 POST提交表单数据
    if request.method == "POST":
        # 将提交的数据保存在表单实例中
        question_post_form = QuestionPostForm(request.POST,request.FILES)

        # 判断提交的数据是否满足模型要求
        if question_post_form.is_valid():
            # 保存新鞋入的title,body
            question_cd = question_post_form.cleaned_data
            question.title = question_cd['title']
            question.description = question_cd['description']
            question.forum=question_cd['forum']

            if request.POST['column'] != 'none':
                question.column = QuestionColumn.objects.get(id=request.POST['column'])
            else:
                question.column = None

            if 'file' in request.FILES:
                print("有文件！")
                question.file = question_cd['file']
            #question.file = question_cd["file"]
            # question.file=rquestion_cd['file']
            question.save()
            # 调用get_absolute_url
            return redirect(question)
        else:
            columns = QuestionColumn.objects.all()
            context = {'question': question, 'columns':columns}
            messages.error(request, "表单内容有误，请重新填写。")
            return render(request, "question/update.html", context)
    # 如果用户get 请求获取数据
    else:
        # 创建表单实例
        question_post_form = QuestionPostForm()
        # 赋值上下文 将question对象也穿进去，方便提取旧的内容
        context = {'question': question, 'question_post_form': question_post_form}
        # 将响应返回到模板中渲染
        return render(request, 'question/update.html', context)


# 删除问题
@login_required(login_url='/userprofile/login/')
def question_delete(request, id):
    # 根据id获取需要删掉的问题
    question = QuestionPost.objects.get(id=id)
    # 只能删除本人的问题
    if request.user != question.author:
        messages.error(request, "抱歉，你无权删除这篇文章")
        return redirect(question)
    # 调用.delete()方法删除问题
    question.delete()
    # 完成后返回文章详情
    return redirect("/")

@login_required(login_url='/userprofile/login/')
def download_file(request,id):
    # print(request)
    # print(id)
    # return HttpResponse('sdf')
    # 判断该用户是否有相关权限
    myuser = User.objects.get(id=request.user.id)
    if not myuser.has_perm('question.view_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')
    question = QuestionPost.objects.get(id=id)
    #
    filename = question.file
    filepath = os.path.join(settings.MEDIA_ROOT, str(filename))

    the_file_name = str(filename).split("/")[-1]  # 显示在弹出对话框中的默认的下载文件名
    # print(the_file_name)
    # filename = '/usr/local/media/file/{}'.format(the_file_name)  # 要下载的文件路径
    fp = open(filepath, 'rb')
    # print("有有有")
    response = StreamingHttpResponse(fp)
    # print("可以看也")
    # response = StreamingHttpResponse(t)
    response['Content-Type'] = 'application/octet-stream'

    response['Content-Disposition'] = 'attachment;filename="{0}"'.format(urlquote(the_file_name.encode('utf8')))
    return response

templates/question/create.html
{% extends "base.html" %}
{% load staticfiles %}

{% block title %}
    发布问题
{% endblock title %}

{% block content %}
 <!-- 
片段名称：发布问题
作者:	ssc
时间：	2020-7-31
功能：	包括两个输入框，用来输入问题的标题和描述
        一个选择框，选择问题的类型，这里给三个可选项
        文件上传，允许浏览系统文件，选择要上传的内容
修改记录： 
-->
<div class="container">
    <div class="row">
        <!--bootstrap框架是栅栏方式，col为12代表是全宽度-->
        <div class="col-12">
            <br>
            <!-- 提交文章的表单 -->
            <form method="post" enctype="multipart/form-data" action=".">
                <!-- Django中需要POST数据的地方都必须有csrf_token -->
                {% csrf_token %}
                <!-- 文章标题 -->
                <div class="form-group">
                    <!-- 标签 -->
                    <label for="title">问题标题</label>
                    <!-- 文本框 -->
                    <input type="text" class="form-control" id="title" name="title" required/>
                </div>
                <!-- 文章正文 -->
                <div class="form-group">
                    <label for="description">问题描述</label>
                    <!-- 文本区域 -->
                    <textarea type="text" class="form-control" id="description" name="description" rows="12" required></textarea>
                </div>
                    <!-- 问题板块 -->
                 <div class="form-group">
                    <label for="column">板块</label>
                     <!-- 文章id和name需要修改！！！ -->
                    <select class="form-control col-3" id="column" name="column" required>
                            <option value="">{请选择板块}..</option>
                            <option value=1>生活</option>
                            <option value=2>学习</option>
                            <option value=3>交友</option>
                        <!-- 如果板块数目动态获取使用下面的内容 -->    
                        <!--  {% for column in columns %}
                            <option value="{{ column.id }}">{{ column }}</option>
                        {% endfor %}-->
                    </select>
                </div>
                <!-- 上传文件 -->
                <div class="form-group">
                    <div class="col-3">
                        <label for="file">上传文件</label> <!--这里是file不是files-->
                        <input type="file" class="form-control-file" name="file" id="file">
                    </div>
                </div>
                <!-- 提交按钮 -->
                <button type="submit" class="btn btn-primary">提交问题</button>
            </form>
        </div>
    </div>
</div>
<!--弹框功能，发布问题成功后弹出-->
{% if messages %}
<!--弹框形式-->
        <script>
            {% for msg in messages %}
                alert('{{ msg.message }}');
            {% endfor %}
        </script>
<!--左下角弹框形式-->
<!--<ul class="messages">-->
<!--    {% for message in messages %}-->
<!--    <li {% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>-->
<!--    {% endfor %}-->
<!--</ul>-->
{% endif %}
{% endblock content %}

templates/question/detail.html
{% extends "base.html" %}

{% load staticfiles %}
{% load like_tags %}
{% load collect_tags %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
问题详情

{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
 <!-- 
片段名称：问题内容显示
作者:	ssc
时间：	2020-7-31
功能：	显示问题的名称，用大号字体显示
        用绿色标注问题的板块，作者等内容，如果有文件，文件名字会显示
        然后在下面显示输入的问题内容,这里的显示支持,markdown
        如果是问题提问者，会有特殊的权限，允许删除和编辑问题，如果是访问者，则不显示
修改记录： 
-->
{% block content %}

<div class="container"> 
    <div class="row">
        <h1 class="col-12 mt-4 mb-4">{{ question.title }}</h1>
        <div class="col-12 alert alert-success">
            <div>
                版块：{{ question.column }}
            </div>
            <div>
                作者：{{ question.author }}
                {% if user == question.author %}
                <!--要修改删除url，去下面scripe中找confirm_delete中的location.href-->
                    <a href="#" onclick="confirm_delete()">删除问题</a>
                    <a href="{% url 'question:question_update' question.id %}">编辑问题</a>
                {% endif %}
            </div>
            {% if question.file %}
            <div style="color:gray">
                附件名称:   {{ question.file }}
            </div>
            {% endif %}
        </div>

        <div class="col-12">
            <p>{{ question.description|safe }} </p>
        </div>
    </div>


<!-- 
片段名称：访问者的操作权限
作者:	qhy
时间：	2020-7-31
功能：	如果有附件，可以下载附件
        点击写回答，，可以进入回答问题界面
        点赞和收藏按钮。点击后，点赞数，收藏数会增加，图标会改变，再次点击可以取消
修改记录： 
-->
        <div class="d-flex justify-content-center">
            {% if question.file %}
            <button type="button" class="btn btn-primary mr-4" onclick="window.location.href='{% url 'question:download_file' question.id %}'">下载附件</button>
            {% endif %}
            <a href="{% url 'answer:answer_create' question.id %}">
                <button type="button" class="btn btn-primary mr-4">写回答</button>
            </a>

            {% if user.is_authenticated %}
            <button type="button" class="btn btn-link" style="text-decoration:none;color:darkslategrey;" onclick="like_change('questionpost', {{ question.id }})">
                    {% if question|add_arg:request.user|call:"question_is_liked" %}
                    <span id="like-container"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="like-container"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                    {% endif %}
                    点赞
                    <span id="likes_number">{% get_likes_num question %}</span>
            </button>

            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('questionpost', {{ question.id }})">
                    {% if question|add_arg:request.user|call:"question_is_collected" %}
                    <span id="collect-container"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="collect-container"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                    {% endif %}
                    收藏
                    <span id="collect_number">{% get_collect_num question %}</span>
            </button>
            {% endif %}
        </div>

<!-- 
片段名称：显示回答
作者:	wzd
时间：	2020-7-31
功能：	显示该问题的回答
        根据角色的不同，回答的发布者或者阅读者，显示不同的操作权限
        点赞和收藏按钮。点击后，点赞数，收藏数会增加，图标会改变，再次点击可以取消
修改记录： 
-->
    <!-- 显示回答 -->
    <h4>共有{{ answers.count }}个回答</h4>
    <div>
        {% for answer in answers %}
        <p>
            <!-- 作者 -->
            <strong style="color: pink">{{ answer.user }}</strong>
        </p>
        <!-- 回答内容 -->
        <pre style="font-family: inherit; font-size: 1em;">{{ answer.body }}</pre>
        <p>
            <ul class="nav nav-tabs">
            <li>
                <span>
                <!-- 下拉列表 -->
                <div class="dropdown"  style="display:inline-block;">
                <button type="button" class="btn dropdown-toggle" id="dropdownMenu1"
                    data-toggle="dropdown" value=".btn .btn-primary"style="height:35px; width:40px;">

                    <span class="caret"></span>
                </button>

                <style type="text/css" rel="stylesheet">a{color:black;}</style>
                <ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
                    {% if answer.file %}
                    <li role="presentation">
                        <a onclick="window.location.href='{% url 'answer:download_file' answer.id %}'" href="#">下载附件</a>
                    </li>
                    {% endif %}

                    {% if user == answer.user %}
                    <li role="presentation">
                        <a  href="{% url 'answer:answer_update' question.id answer.id %}">编辑回答</a>
                    </li>
                    <li role="presentation">
                        <a href="#" onclick="confirm_delete_comment({{  question.id}}, {{ answer.id }})">删除该回答</a>
                    </li>
                    {% endif %}

                    <li role="presentation">
                        等待更多操作...
                    </li>
                </ul>
            </div>

                </span>
            </li>

            <!-- 点赞 -->
            {% if user.is_authenticated %}
            <li>
            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="like_change('answer', {{ answer.id }})">
                {% if answer|add_arg:request.user|call:"answer_is_liked" %}
                <span id="like-container{{answer.id}}"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                {% else %}
                <span id="like-container{{answer.id}}"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                {% endif %}
                点赞
                <span id="likes_number{{answer.id}}">{% get_likes_num answer %}</span>
            </button>
            </li>

            <!-- 收藏 -->
            <li>
            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('answer', {{ answer.id }})">
                {% if answer|add_arg:request.user|call:"answer_is_collected" %}
                <span id="collect-container{{answer.id}}"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                {% else %}
                <span id="collect-container{{answer.id}}"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                {% endif %}
                收藏
                <span id="collect_number{{answer.id}}">{% get_collect_num answer %}</span>
            </button>
            </li>
            {% endif %}
            <!-- 时间 -->
            <li>
                <span style="color: green">{{ answer.created|date:"Y-m-d H:i:s" }}</span>
            </li>
            </ul>
        </p>
        {% endfor %}
    </div>


</div>

{% if messages %}
<!--弹框形式-->
<script>
    {% for msg in messages %}
        alert('{{ msg.message }}');
    {% endfor %}
</script>
<!--{% endif %}-->

{% endblock content %}

{% block script %}

<script>
//函数功能：弹框确认是否删除，确认删除则调用删除函数
//作者：    ssc
//时间：	2020-7-31
//修改记录：
function confirm_delete() {
    // 调用layer弹窗组件
    layer.open({
        // 弹窗标题
        title: "确认删除",
        // 正文
        content: "确认删除该问题吗？",
        // 点击确定按钮后调用的回调函数
        yes: function(index, layero) {
            // 指定应当前往的 url
            location.href='{% url 'question:question_delete' question.id %}'
        },
    })
}
//函数功能：弹框确认是否删除，确认删除则调用删除函数
//作者：    ssc
//时间：	2020-7-31
//修改记录：
function confirm_delete_comment(question_id, answer_id) {
    // 调用layer弹窗组件
    layer.open({
        // 弹窗标题
        title: "确认删除",
        // 正文
        content: "确认删除该回答吗？",
        // 点击确定按钮后调用的回调函数
        yes: function(index, layero) {
            // 指定应当前往的 url
            var url = "{% url 'answer:answer_delete' 210000000 220000000 %}";
            url = url.replace(/210000000/, question_id);
            url = url.replace(/220000000/, answer_id);
            location.href=url
        },
    });
}
//函数功能：点赞收藏函数的js函数，改变图标形式
//作者：    qhy
//时间：	2020-7-31
//修改记录：
    function like_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'like:like_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost"){
                    if(data.is_liked){
                        $("#like-container").html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $("#like-container").html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    $("#likes_number").html(data.likes_num);
                }
                else{
                    var container = '#like-container'+object_id;
                    if(data.is_liked){
                        $(container).html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    var number = '#likes_number'+object_id;
                    $(number).html(data.likes_num);
                }

            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }

    function collect_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'collect:collect_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost") {
                    if (data.is_collected) {
                        $("#collect-container").html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    } else {
                        $("#collect-container").html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    $("#collect_number").html(data.collect_num);
                }
                else{
                    var container = '#collect-container'+object_id;
                    if(data.is_collected){
                        $(container).html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    var number = '#collect_number'+object_id;
                    $(number).html(data.collect_num);
                }
            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }

</script>

{% endblock script %}